package jp.co.sds_corp.util.diag;

import java.applet.Applet;
import java.net.CookieManager;
import java.net.CookieStore;
import java.net.HttpCookie;
import java.util.ArrayList;
import java.util.List;

import jp.co.sds_corp.util.log.CmnLogFactory;
import jp.co.sds_corp.util.log.CmnLogger;

public class AppletDiagnostics
{
	static final CmnLogger logger = CmnLogFactory.getLogger();

	public void displayApplet(Applet applet) {
		List<String> list = getApplet(applet);
		for (String msg : list) {
			logger.info(this, msg);
		}
	}
	public List<String> getApplet(Applet applet) {
		ArrayList<String> ret = new ArrayList<String>();
		ret.add("=== applet ===");
		ret.add(applet.toString()
				+ ",info=" + applet.getAppletInfo());
		ret.add("PARAM=" + applet.getParameter("PARAM"));
		ret.add("local=" + applet.getParameter("local"));
		ret.add("CodeBase=" + applet.getCodeBase());
		ret.add("DocumentBase=" + applet.getDocumentBase());
		StringBuilder log = new StringBuilder();
		String[][] params = applet.getParameterInfo();
		if (params != null) {
			for (String[] param : params) {
				log.append("{");
				for (String var : param) {
					log.append(var + ",");
				}
				log.append("},");
			}
			ret.add("params=" + log.toString());
		}
		return ret;
	}

	public void displayCookie(CookieManager manager) {
		List<String> ret = getCookie(manager);
		for (String msg : ret) {
			logger.info(this, msg);
		}
	}
	public List<String> getCookie(CookieManager manager) {
		ArrayList<String> ret = new ArrayList<String>();
		CookieStore store = manager.getCookieStore();
		List<HttpCookie> cookies = store.getCookies();
		ret.add("=== Cookies ===");
		for (HttpCookie cookie : cookies) {
			ret.add(cookie.getName() + "=" + cookie.getValue()
				+ ",domain=" + cookie.getDomain()
				+ ",path=" + cookie.getPath()
				+ ",maxage=" + cookie.getMaxAge()
				+ ",port=" + cookie.getPortlist());
		}
		return ret;
	}

}
