package	jp.co.sds_corp.util.log;

import java.util.logging.Level;

/**
* ログを出力します。
* @author	小見山　聡
*/
public class CmnLogFactory
{
	private static CmnLogFactory instance = new CmnLogFactory();
	private static ConsoleLogger console = ConsoleLogger.getInstance();
	private CmnLogger logger;
	private boolean initialized = false;

	private CmnLogFactory() {
	}

	public static CmnLogFactory getInstance() {
		if ( !instance.initialized ) {
			instance.initLogger();
			instance.initialized = true;
		}
		return instance;
	}

	void initLogger() {
		logger = initJdkLogger();
	}

	JdkLogger initJdkLogger() {
		JdkLogger jdkLogger = JdkLogger.getInstance();
		LogLoader loader = null;;
		try {
			loader = new LogLoader();
			loader.init();
		} catch ( Exception ex ) {
			console.error( this, "log config load error.", ex );
		}
		jdkLogger.rootLogger = jdkLogger.getLogger( loader.getRoot() );
		jdkLogger.needCaller = jdkLogger.rootLogger.isLoggable( Level.FINER );
		jdkLogger.info(this, "root " + jdkLogger.rootLogger.getName()
				+ " needCaller=" + jdkLogger.needCaller);
		return jdkLogger;
	}

	public static ConsoleLogger getConsoleLogger() {
		return console;
	}

	public static CmnLogger getLogger() {
		return getInstance().logger;
	}

}
