package	jp.co.sds_corp.util.log;

import java.util.logging.Level;

/**
* ログを出力します。
* @author	小見山　聡
*/
public interface CmnLogger
{
	/**
	 * @param	obj		log の出力を行なったClass。
	 * @param	level	log の出力レベル
	 */
	public boolean isLoggable( Object obj, Level level );
	/**
	 * @param	obj		log の出力を行なったClass。
	 */
	public boolean isTraceEnable( Object obj );
	/**
	 * @param	obj		log の出力を行なったClass。
	 */
	public boolean isDebugEnable( Object obj );
	/**
	 * @param	obj		log の出力を行なったClass。
	 */
	public boolean isDetailEnable( Object obj );
	/**
	 * @param	obj		log の出力を行なったClass。
	 * @param	logMsg	出力するメッセージ
	 */
	public void trace( Object obj, String logMsg );
	/**
	 * @param	obj		log の出力を行なったClass。
	 * @param	logMsg	出力するメッセージ
	 * @param	t		出力する例外
	 */
	public void trace( Object obj, String logMsg, Throwable t );
	/**
	 * @param	obj		log の出力を行なったClass。
	 * @param	logMsg	出力するメッセージ
	 */
	public void debug( Object obj, String logMsg );
	/**
	 * @param	obj		log の出力を行なったClass。
	 * @param	logMsg	出力するメッセージ
	 * @param	t		出力する例外
	 */
	public void debug( Object obj, String logMsg, Throwable t );
	/**
	 * @param	obj		log の出力を行なったClass。
	 * @param	logMsg	出力するメッセージ
	 */
	public void detail( Object obj, String logMsg );
	/**
	 * @param	obj		log の出力を行なったClass。
	 * @param	logMsg	出力するメッセージ
	 * @param	t		出力する例外
	 */
	public void detail( Object obj, String logMsg, Throwable t );
	/**
	 * @param	obj		log の出力を行なったClass。
	 * @param	logMsg	出力するメッセージ
	 */
	public void info( Object obj, String logMsg );
	/**
	 * @param	obj		log の出力を行なったClass。
	 * @param	logMsg	出力するメッセージ
	 * @param	t		出力する例外
	 */
	public void info( Object obj, String logMsg, Throwable t );
	/**
	 * @param	obj		log の出力を行なったClass。
	 * @param	logMsg	出力するメッセージ
	 */
	public void warn( Object obj, String logMsg );
	/**
	 * @param	obj		log の出力を行なったClass。
	 * @param	logMsg	出力するメッセージ
	 * @param	t		出力する例外
	 */
	public void warn( Object obj, String logMsg, Throwable t );
	/**
	 * @param	obj		log の出力を行なったClass。
	 * @param	logMsg	出力するメッセージ
	 */
	public void error( Object obj, String logMsg );
	/**
	 * @param	obj		log の出力を行なったClass。
	 * @param	logMsg	出力するメッセージ
	 * @param	t		出力する例外
	 */
	public void error( Object obj, String logMsg, Throwable t );
	/**
	 * @param	obj		log の出力を行なったClass。
	 * @param	logMsg	出力するメッセージ
	 */
	public void fatal( Object obj, String logMsg );
	/**
	 * @param	obj		log の出力を行なったClass。
	 * @param	logMsg	出力するメッセージ
	 * @param	t		出力する例外
	 */
	public void fatal( Object obj, String logMsg, Throwable t );
	/**
	 * @param	obj		log の出力を行なったClass。
	 * @param	ex		出力する例外
	 */
	public void exception( Object obj, Throwable ex );
	/**
	 * @param	obj		log の出力を行なったClass。
	 * @param	level	log の出力レベル
	 * @param	ex		出力する例外
	 */
	public void exception( Object obj, Level level, Throwable ex );
	/**
	 * @param	obj		log の出力を行なったClass。
	 */
	public void sql( Object obj, String sql );

}
