package	jp.co.sds_corp.util.math;


/**
* 立方根を求めます。
*/
public class CubicRoot
{
	/**
	* 立方根を求める (戻り値 = double)
	*/
	public static double doubleCuberoot(double x) {
		if (x == 0) {
			return 0;
		}
		int sign = (x > 0) ? 1 : -1;
		if (sign == -1) {
			x = -x;
		}
		double s = 1, prev;
		if (x > 1) {
			s = x;
		}
		do {
			prev = s; 
			double t = s * s;
			s += (x - t * s) / (2 * t + x / s);
		} while (s < prev);
		return sign * prev;
	}

	/**
	* 立方根を求める (戻り = int)
	*/
	public static int intCuberoot(int x) {
		if (x == 0) {
			return 0;
		}
		int sign = (x > 0) ? 1 : -1;
		if (sign == -1) {
			x = -x;
		}
		int s = 1, t = x;
		while (s < t) {
			s <<= 1;
			t >>= 2;
		}
		do {
			t = s;
			s = (x / (s * s) + 2 * s) / 3;
		} while (s < t);
		return sign * t;
	}
}
