package	jp.co.sds_corp.util.math;

import java.io.PrintStream;
import java.io.PrintWriter;

/**
* 計算関数でのException情報を保持します。
*/
public class UtilMathException extends Exception
{
	private static final long serialVersionUID = 1L;
	protected final Exception thrown;
	protected String error_message="";
	protected int error_code;

	public static final int IGAMMA_EXCEPTION    = 1000;
	public static final int BSMODEL_EXCEPTION   = 1001;
	public static final int BISECTION_EXCEPTION = 1002;
	public static final int GOALSEEK_EXCEPTION  = 1003;
	public static final int SERIAL_EXCEPTION    = 1004;

	public UtilMathException(Exception _thrown) {
		super("util.math.UtilMathException:" + _thrown.getMessage());
		thrown  = _thrown;
	}

	public UtilMathException(String _error_message, Exception _thrown) {
		super("util.math.UtilMathexception:" + _thrown.getMessage());
		thrown = _thrown;
		error_message = _error_message;
	}

	public UtilMathException(int _error_code, String _error_message, Exception _thrown)
	{
		super("util.math.UtilMathexception:" + _thrown.getMessage());
		thrown = _thrown;
		error_message = _error_message;
		error_code = _error_code;
	}
		
	public String getLocalizedMessage() {
		return "util.math.UtilMathexception:" + thrown.getLocalizedMessage();
	}

	public void printStackTrace() {
		thrown.printStackTrace();
	}
	public void printStackTrace(PrintStream ps) {
		thrown.printStackTrace(ps);
	}
	public void printStackTrace(PrintWriter pw) {
		thrown.printStackTrace(pw);
	}
	public Exception getThrown() {
		return thrown;
	}
	public String getError_message() {
		return error_message;
	}
	public int getError_code() {
		return error_code;
	}
}
