package	jp.co.sds_corp.util.net;

/**
* IPヘッダの情報を保持します。
*/
public class IPHeader
{
	byte	version;		/* IP Version (4bit) */
	byte	ihl;			/* Internet Header Length(octet) (4bit) */
	byte	tos;			/* Type of Service */
	int		totalLength;	/* Total Length */
	int		identification;	/* Identification */
	byte	flags;			/* Flags (3bit) */
	int		flagment;		/* Flagment Offset (13bit) */
	byte	ttl;			/* Time to Live */
	byte	protocol;		/* Protocol */
	int		checksum;		/* Header Checksum */
	byte[]	source = new byte[4];	/* Source Address */
	byte[]	dest = new byte[4];	/* Destination Address */

	/**
	* IP Version(version)を設定します。
	* @param	var		設定するデータ
	*/
	public void setVersion( byte var ) {
		this.version = var;
	}
	/**
	* IP Version(version)を取得します。
	* @return	versionの内容
	*/
	public byte getVersion() {
		return version;
	}

	/**
	* Internet Header Length(ihl)を設定します。
	* @param	var		設定するデータ
	*/
	public void setIhl( byte var ) {
		this.ihl = var;
	}
	/**
	* Internet Header Length(ihl)を取得します。
	* @return	ihlの内容
	*/
	public byte getIhl() {
		return ihl;
	}

	/**
	* Type of Service(tos)を設定します。
	* @param	var		設定するデータ
	*/
	public void setTos( byte var ) {
		this.tos = var;
	}
	/**
	* Type of Service(tos)を取得します。
	* @return	tosの内容
	*/
	public byte getTos() {
		return tos;
	}

	/**
	* Total Length(totalLength)を設定します。
	* @param	var		設定するデータ
	*/
	public void setTotalLength( int var ) {
		this.totalLength = var;
	}
	/**
	* Total Length(totalLength)を取得します。
	* @return	totalLengthの内容
	*/
	public int getTotalLength() {
		return totalLength;
	}

	/**
	* Identification(identification)を設定します。
	* @param	var		設定するデータ
	*/
	public void setIdentification( int var ) {
		this.identification = var;
	}
	/**
	* Identification(identification)を取得します。
	* @return	identificationの内容
	*/
	public int getIdentification() {
		return identification;
	}

	/**
	* Flags(flags)を設定します。
	* @param	var		設定するデータ
	*/
	public void setFlags( byte var ) {
		this.flags = var;
	}
	/**
	* Flags(flags)を取得します。
	* @return	flagsの内容
	*/
	public byte getFlags() {
		return flags;
	}

	/**
	* Flagment Offset(flagment)を設定します。
	* @param	var		設定するデータ
	*/
	public void setFlagment( int var ) {
		this.flagment = var;
	}
	/**
	* Flagment Offset(flagment)を取得します。
	* @return	flagmentの内容
	*/
	public int getFlagment() {
		return flagment;
	}

	/**
	* Time to Live(ttl)を設定します。
	* @param	var		設定するデータ
	*/
	public void setTtl( byte var ) {
		this.ttl = var;
	}
	/**
	* Time to Live(ttl)を取得します。
	* @return	ttlの内容
	*/
	public byte getTtl() {
		return ttl;
	}

	/**
	* Protocol(protocol)を設定します。
	* @param	var		設定するデータ
	*/
	public void setProtocol( byte var ) {
		this.protocol = var;
	}
	/**
	* Protocol(protocol)を取得します。
	* @return	protocolの内容
	*/
	public byte getProtocol() {
		return protocol;
	}

	/**
	* Header Checksum(checksum)を設定します。
	* @param	var		設定するデータ
	*/
	public void setChecksum( int var ) {
		this.checksum = var;
	}
	/**
	* Header Checksum(checksum)を取得します。
	* @return	checksumの内容
	*/
	public int getChecksum() {
		return checksum;
	}

	/**
	* Source Address(source)を設定します。
	* @param	var		設定するデータ
	*/
	public void setSource( byte[] var ) {
		this.source = var;
	}
	/**
	* Source Address(source)を取得します。
	* @return	sourceの内容
	*/
	public byte[] getSource() {
		return source;
	}

	/**
	* Destination Address(dest)を設定します。
	* @param	var		設定するデータ
	*/
	public void setDest( byte[] var ) {
		this.dest = var;
	}
	/**
	* Destination Address(dest)を取得します。
	* @return	destの内容
	*/
	public byte[] getDest() {
		return dest;
	}

}
