package jp.co.sds_corp.util;

import java.lang.reflect.Method;
import java.util.logging.Level;

import org.seasar.framework.aop.Aspect;
import org.seasar.framework.aop.Pointcut;
import org.seasar.framework.aop.impl.AspectImpl;
import org.seasar.framework.aop.impl.PointcutImpl;
import org.seasar.framework.aop.interceptors.InterceptorChain;
import org.seasar.framework.aop.proxy.AopProxy;

import jp.co.sds_corp.test.BasicTestCase;
import jp.co.sds_corp.util.log.CmnLogFactory;
import jp.co.sds_corp.util.log.ConsoleLogger;

public class AopTest extends BasicTestCase
{
	static final ConsoleLogger console = CmnLogFactory.getConsoleLogger();

	public void setUp() throws Exception {
		super.setUp();
		console.setLevel( Level.ALL );
	}

    /**
     */
    public void test1() throws Exception {
		InterceptorChain chain = new InterceptorChain();
		AopProxy proxy = new AopProxy(getClass(),
			new Aspect[] {
				new AspectImpl(
					chain,
					new Pointcut() {
						private final Pointcut base =
							new PointcutImpl(new String[] {"^.*$", });
						private final Pointcut ignore =
							new PointcutImpl(new String[] {"^(getClass|notify|notifyAll|wait)$", });
						@Override
						public boolean isApplied(Method method) {
							return !ignore.isApplied(method) &&
								base.isApplied(method);
						}
					}
				)
			}
		);
	}

/*
	public void testConnectionTx() throws Exception {
		IConfiguration config = new DOMConfiguration("target/test-classes/DbEnv.xml").getChild("db");
		DbInfo info = DbConnectionFactory.getDbInfo(config);
		Connection con = DbConnectionFactory.getConnection(info);
		Statement stmt = con.createStatement();
		stmt.close();
	}
*/
}
