package jp.co.sds_corp.util.crypt;

import java.io.File;

import jp.co.sds_corp.test.BasicTestCase;
import jp.co.sds_corp.util.log.CmnLogFactory;
import jp.co.sds_corp.util.log.CmnLogger;

public class PKCS8PBECipherTest extends BasicTestCase
{
	static final CmnLogger logger = CmnLogFactory.getLogger();
	static final String plain = "abc123";

	public void setUp() throws Exception {
		super.setUp();
	}

	public void testEncrypt1() throws Exception {
		logger.debug(this, "===== testEncrypt1");
		ICipher cipher = new PKCS8PBECipher(new File("target/test-classes/private_key_pwd.der"));
		((PKCS8PBECipher )cipher).setPassword("zaq12wsx");
		byte[] encrypted = cipher.encrypt(plain.getBytes());
		logger.debug(this, "encrypted=" + new Base64Encoder().encode(encrypted));

		ICipher decipher = new X509Cipher(new File("target/test-classes/public_key.der"));
		byte[] decrypted = decipher.decrypt(encrypted);
		String sdec = new String(decrypted);
		logger.debug(this, "decrypted=" + sdec);
		assertEquals("decrypted", plain, sdec);
	}

	public void testDecrypt1() throws Exception {
		logger.debug(this, "===== testDecrypt1");
		ICipher cipher = new X509Cipher(new File("target/test-classes/public_key.der"));
		byte[] encrypted = cipher.encrypt(plain.getBytes());
		logger.debug(this, "encrypted=" + new Base64Encoder().encode(encrypted));

		PKCS8PBECipher decipher = new PKCS8PBECipher(new File("target/test-classes/private_key_pwd.der"));
		decipher.setPassword("zaq12wsx");
		byte[] decrypted = decipher.decrypt(encrypted);
		String sdec = new String(decrypted);
		logger.debug(this, "decrypted=" + sdec);
		assertEquals("decrypted", plain, sdec);
	}

}
