package jp.co.sds_corp.util.thread;

import jp.co.sds_corp.test.BasicTestCase;
import jp.co.sds_corp.util.log.CmnLogFactory;
import jp.co.sds_corp.util.log.CmnLogger;

public class ThreadMonitorTest extends BasicTestCase
{
	static final CmnLogger logger = CmnLogFactory.getLogger();

	public void setUp() throws Exception {
		super.setUp();
	}

	public class TestRunner implements Runnable {
		boolean stop = false;
		public void run() {
			for ( ;; ) {
				synchronized(this) {
					if (stop) {
						break;
					}
				}
				try {
					Thread.sleep(100);
				} catch (Exception ex) {
				}
			}
		}
		public synchronized void stop() {
			this.stop = true;
		}
	}

	public void testMonitor1() throws Exception {
		String log;
		ThreadMonitor monitor = new ThreadMonitor();
		log = monitor.getString();
		logger.debug(this, "log=[\n" + log);
	}

	public void testMonitor2() throws Exception {
		ThreadGroup group = new ThreadGroup("testGroup");
		TestRunner runner = new TestRunner();
		Thread thread = new Thread(group, runner, "testThread");
		thread.start();

		String log;
		ThreadMonitor monitor = new ThreadMonitor();
		log = monitor.getString();
		logger.debug(this, "log=[\n" + log);
		runner.stop();
		try {
			thread.join();
		} catch (Exception ex) {
		}

		log = monitor.getString();
		logger.debug(this, "after stop=[\n" + log);
	}

	public void testMonitor3() throws Exception {
		ThreadGroup group = new ThreadGroup("testGroup");
		group.setDaemon(true);
		TestRunner runner = new TestRunner();
		Thread thread = new Thread(group, runner, "testThread");
		thread.start();

		String log;
		ThreadMonitor monitor = new ThreadMonitor(group);
		log = monitor.getString();
		logger.debug(this, "log=[\n" + log);
		runner.stop();
		try {
			thread.join();
		} catch (Exception ex) {
		}

		log = monitor.getString();
		logger.debug(this, "after stop=[\n" + log);
	}

}
